#!/bin/sh
##
# @(#) Provision_Script v1.0 Installs the Device Certificate and the Device
# @(#) Private Key
# @(#) 
# @(#) Date: 05 Sept 2006

CERT_PATHS="/mmc/mma1/certs /ezxlocal/certs"

#Attempt to find a new root, [ca], dev, amd key  wherever the user has specified
if [ -n "$1" -a -f "$1" ] && [ -n "$2" -a -f "$2" ] && [ -n "$3" -a -f "$3" ] && [ -n "$4" -a -f "$4" ]; then
    dev=$1
    ca=$2
    root=$3
    key=$4
elif [ -n "$1" -a -f "$1" ] && [ -n "$2" -a -f "$2" ] && [ -n "$3" -a -f "$3" ]; then
    dev=$1
    root=$2
    key=$3
#Use default Coremedia certs
elif [ -n "$1" -a -f "$1" ] && [ -n "$2" -a -f "$2" ]; then
    dev=$1
    ca="/usr/testuda/OMADRMV2_TestData/cert/ca.pem"
    root="/usr/testuda/OMADRMV2_TestData/cert/root.pem"
    key=$2
#Attempt to find a new root, [ca], dev, and key in /mmc/mma1/certs (memory card)
else
    for x in $CERT_PATHS; do 
        echo $x
        if [ -f "$x/dev.pem" ] && [ -f "$x/root.pem" ] && [ -f "$x/key.der" ]; then
            dev="$x/dev.pem"
            root="$x/root.pem"
            key="$x/key.der"
            if [ -f "$x/ca.pem" ]; then
                ca="$x/ca.pem" 
            fi
        fi
    done

    if [ ! -f "$dev" ]; then
        USAGE="USAGE: `basename $0` <device certificate> <device private key> " 1>&2
        EXAMPLE1="Example -`basename $0` /tmp/dev103.pem /tmp/key103.der"

        echo ""
        echo "`basename $0`: argument error"
        echo $USAGE
        echo ""
        echo $EXAMPLE1
        echo ""
        exit 1
    fi
fi

#Provision the root cert.  This must be run every time.
umount /usr/securesetup/.policy/_certmgt_domain.txt
mkdir -p /ezxlocal/.policy/
rm -f /ezxlocal/.policy/_certmgt_domain.txt
cp -f /usr/securesetup/.policy/_certmgt_domain.txt /ezxlocal/.policy/
chmod 777 /ezxlocal/.policy/_certmgt_domain.txt
echo "domain: OMATestRoot" >> /ezxlocal/.policy/_certmgt_domain.txt
#Switch to 103 for CMLA testing.
echo "type: 102" >> /ezxlocal/.policy/_certmgt_domain.txt
echo -n "rootcert: " >> /ezxlocal/.policy/_certmgt_domain.txt
cat $root >> /ezxlocal/.policy/_certmgt_domain.txt
#echo "">>/ezxlocal/.policy/_certmgt_domain.txt
echo "allowinstall: 1" >> /ezxlocal/.policy/_certmgt_domain.txt
mount -o bind /ezxlocal/.policy/_certmgt_domain.txt /usr/securesetup/.policy/_certmgt_domain.txt



. /etc/initservices/services/ezxenv.sh

#Provision the device:
#Test Commands tool has and entry in the OS's RAC list. 
#We hijack it to allow us to have permission to write
#to the private key store and to read from the private
#key store.
umount /bin/tcmd

mount -o bind /usr/testuda/provision_drm_pki /bin/tcmd

if [ -f $ca ]; then
/bin/tcmd -n -c $dev -c $ca -k $key
else
/bin/tcmd -n -c $dev -k $key
fi

umount  /bin/tcmd



