#!/bin/bash
 #set -x

export OADB_PARTIAL_PATH="/usr/testuda/OMADRM_TestData/"
export OADB_STAGING_ROOT_PATH=$OADB_PARTIAL_PATH"oadb"


function showHelp()
{
    printf 'A testing utility for OMA 2 DRM test \n\n'
    printf 'v2testutil can be used to cleanup oadb, usage is: v2testutil cleanup [all|RI|RO|DO]\n' 
    printf 'v2testutil cleanup RI [all|<RI_ID>] \n' 
    printf '\tcleanup RI context. Use all for complete cleanup, use <RI_ID> for individual RI context cleanup \n' 
    printf 'v2testutil cleanup RO [all|<RO_ID>]\n' 
    printf '\tcleanup RO context. Use all for complete cleanup, use <RO_ID> for individual RO context cleanup \n' 
    printf 'v2testutil cleanup DO [all|<DOMAIN_ID>]\n' 
    printf '\tcleanup Domain context. Use all for complete cleanup, use <DOMAIN_ID> for individual Domain context cleanup \n\n' 
    printf 'v2testutil can be used to operate certificate, usage is:: v2testutil cert [get/revoke]\n' 
    printf 'v2testutil cert get\n' 
    printf '\tcertificate provisioining  \n' }
    printf 'v2testutil cert revoke\n' 
    printf '\tcertificate revoke  \n' 
  }    
### oadb cleanup
function doIndividualCleanup()
{
  echo "TODO: cleanup $1 with id $2"
}

function doCleanupRO()
{
    echo "Cleaning up all RO context ....$1"
    if [ -n $1 ]  # cleanup individual RO context by ROID
      then
           doIndividualCleanup "RO"  $1
    else  # cleanup all RO context
      if [ -e $OADB_STAGING_ROOT_PATH/data/AssetRO ]
        then
          rm -f $OADB_STAGING_ROOT_PATH/data/AssetRO
      fi    
      if [ -e $OADB_STAGING_ROOT_PATH/data/DomainRO ]
        then
        rm -f $OADB_STAGING_ROOT_PATH/data/DomainRO
      fi
      if [ -e $OADB_STAGING_ROOT_PATH/data/RightsObject ]
        then
          rm -f $OADB_STAGING_ROOT_PATH/data/RightsObject
      fi    
      if [ -e $OADB_STAGING_ROOT_PATH/data/RIRO ]
        then
          rm -f $OADB_STAGING_ROOT_PATH/data/RIRO
      fi   
      if [ -e $OADB_STAGING_ROOT_PATH/data/RightsObjectXML ]
        then
          rm -f $OADB_STAGING_ROOT_PATH/data/RightsObjectXML
      fi   
    fi
}
function doCleanupRI()
{
    echo "Cleaning up all RI context ....$1"
    if [ -n $1 ]  # cleanup individual RI context by RIID
      then
           doIndividualCleanup "RI"  $1
    else  # cleanup all RI context    
      if [ -e $OADB_STAGING_ROOT_PATH/data/RIContext ]
        then
          rm -f $OADB_STAGING_ROOT_PATH/RIContext 
      fi    
      if [ -e $OADB_STAGING_ROOT_PATH/data/RiDomain ]
        then
          rm -f $OADB_STAGING_ROOT_PATH/data/RiDomain 
      fi
      if [ -e $OADB_STAGING_ROOT_PATH/data/RIRO ]
        then
          rm -f $OADB_STAGING_ROOT_PATH/data/RIRO 
      fi
    fi
}
function doCleanupDO()
{
    echo "Cleaning up all Domain context ....$1"
    if [ -n $1 ]  # cleanup individual Domain context by DOID
      then
           doIndividualCleanup "DO"  $1
    else  # cleanup all Domain context    
        if [ -e $OADB_STAGING_ROOT_PATH/data/DomainContext ]
          then
            rm -f $OADB_STAGING_ROOT_PATH/data/DomainContext
        fi 
        if [ -e $OADB_STAGING_ROOT_PATH/data/DomainRO ]
          then
            rm -f $OADB_STAGING_ROOT_PATH/data/DomainRO
        fi 
        if [ -e $OADB_STAGING_ROOT_PATH/data/RiDomain ]
          then
            rm -f $OADB_STAGING_ROOT_PATH/data/RiDomain
        fi 
    fi
}
function doCleanupAll()
{
    echo "Cleaning up all subdirectories in $OADB_STAGING_ROOT_PATH ...."
    if [ -d $OADB_STAGING_ROOT_PATH/data ]
    then
        rm -f $OADB_STAGING_ROOT_PATH/data/*
    fi    
    if [ -d $OADB_STAGING_ROOT_PATH/tmp ]
      then
        rm -f $OADB_STAGING_ROOT_PATH/tmp/*
    fi
    if [ -d $OADB_STAGING_ROOT_PATH/log ]
      then
        rm -f $OADB_STAGING_ROOT_PATH/log/*
    fi
}
####### $1 - type of cleanup, $2 - RO/RI/DOmain ID for individual cleanup
function doCleanup()
{
    echo "Cleaning up subdirectories in $OADB_STAGING_ROOT_PATH .... for $1 context [$2] "
    if [ $1 = all ]    
      then
        doCleanupAll 
    elif [ $1 = RO ]	
      then
        doCleanupRO $2
    elif [ $1 = RI ]	
      then
        doCleanupRI $2
    elif [ $1 = DO ]	
      then
        doCleanupDO  $2
    else
       echo "Invalid input $1"
        showHelp 
 fi	
}

### certificate provisioning
function doCert()
{
    echo "do certifcate related opration.."
}



case "$1" in
	cleanup)
		doCleanup $2 $3
	;;
	cert)
		doCert $2 $3
	;;
	*)
		echo "Usage: v2testutil [command] [argument1] [argument2] "
              showHelp
esac              